#ifndef __FILTER_H__
#define __FILTER_H__

typedef struct _Filter	Filter;

typedef enum
{
	FLT_CONTAIN	= 1 << 0,
	FLT_CASE_SENS	= 1 << 1
} FilterFlag;

typedef enum
{
	FLT_AND,
	FLT_OR,
	FLT_NOT
} FilterCond;

typedef enum
{
	FLT_MOVE,
	FLT_NOTRECV,
	FLT_DELETE
} FilterAction;

#define FLT_IS_CONTAIN(flag)	((flag & FLT_CONTAIN) != 0)
#define FLT_IS_CASE_SENS(flag)	((flag & FLT_CASE_SENS) != 0)

struct _Filter
{
	gchar *name1;
	gchar *body1;

	gchar *name2;
	gchar *body2;

	FilterFlag flag1;
	FilterFlag flag2;

	FilterCond cond;

	/* destination folder */
	gchar *dest;

	FilterAction action;
};

#define FILTER_NOT_RECEIVE	"//NOT_RECEIVE//"

gchar *filter_get_dest_folder	(GSList		*fltlist,
				 const gchar	*file);
gboolean filter_match_condition	(Filter		*filter,
				 GSList		*hlist);
gchar *filter_get_str		(Filter		*filter);
Filter *filter_read_str		(const gchar	*str);
void filter_free		(Filter		*filter);

#endif /* __FILTER_H__ */
